# -*- encoding: utf-8 -*-

Gem::Specification.new do |s|
  s.name = %q{snmp}
  s.version = "1.0.2"

  s.required_rubygems_version = Gem::Requirement.new(">= 0") if s.respond_to? :required_rubygems_version=
  s.authors = ["Dave Halliday"]
  s.date = %q{2007-12-28}
  s.description = %q{A Ruby implementation of SNMP (the Simple Network Management Protocol).}
  s.email = %q{hallidave@gmail.com}
  s.extra_rdoc_files = ["README"]
  s.files = ["Rakefile", "README", "setup.rb", "lib/snmp/agent.rb", "lib/snmp/ber.rb", "lib/snmp/manager.rb", "lib/snmp/mib.rb", "lib/snmp/pdu.rb", "lib/snmp/varbind.rb", "lib/snmp.rb", "test/test_ber.rb", "test/test_manager.rb", "test/test_mib.rb", "test/test_pdu.rb", "test/test_retry.rb", "test/test_smi.rb", "test/test_varbind.rb", "test/test_walk.rb", "test/if_table1.yaml", "test/if_table6.yaml", "examples/datetime.rb", "examples/dump.rb", "examples/get.rb", "examples/iftable.rb", "examples/link_down.rb", "examples/log_traps.rb", "examples/set.rb", "examples/walk.rb", "data/ruby/snmp/mibs/ACCOUNTING-CONTROL-MIB.yaml", "data/ruby/snmp/mibs/ADSL-LINE-EXT-MIB.yaml", "data/ruby/snmp/mibs/ADSL-LINE-MIB.yaml", "data/ruby/snmp/mibs/ADSL-TC-MIB.yaml", "data/ruby/snmp/mibs/AGENTX-MIB.yaml", "data/ruby/snmp/mibs/APM-MIB.yaml", "data/ruby/snmp/mibs/APPC-MIB.yaml", "data/ruby/snmp/mibs/APPLETALK-MIB.yaml", "data/ruby/snmp/mibs/APPLICATION-MIB.yaml", "data/ruby/snmp/mibs/APPN-DLUR-MIB.yaml", "data/ruby/snmp/mibs/APPN-MIB.yaml", "data/ruby/snmp/mibs/APPN-TRAP-MIB.yaml", "data/ruby/snmp/mibs/APS-MIB.yaml", "data/ruby/snmp/mibs/ATM-ACCOUNTING-INFORMATION-MIB.yaml", "data/ruby/snmp/mibs/ATM-MIB.yaml", "data/ruby/snmp/mibs/ATM-TC-MIB.yaml", "data/ruby/snmp/mibs/ATM2-MIB.yaml", "data/ruby/snmp/mibs/BGP4-MIB.yaml", "data/ruby/snmp/mibs/BLDG-HVAC-MIB.yaml", "data/ruby/snmp/mibs/BRIDGE-MIB.yaml", "data/ruby/snmp/mibs/CHARACTER-MIB.yaml", "data/ruby/snmp/mibs/CIRCUIT-IF-MIB.yaml", "data/ruby/snmp/mibs/CLNS-MIB.yaml", "data/ruby/snmp/mibs/COFFEE-POT-MIB.yaml", "data/ruby/snmp/mibs/COPS-CLIENT-MIB.yaml", "data/ruby/snmp/mibs/DECNET-PHIV-MIB.yaml", "data/ruby/snmp/mibs/DIAL-CONTROL-MIB.yaml", "data/ruby/snmp/mibs/DIFFSERV-CONFIG-MIB.yaml", "data/ruby/snmp/mibs/DIFFSERV-DSCP-TC.yaml", "data/ruby/snmp/mibs/DIFFSERV-MIB.yaml", "data/ruby/snmp/mibs/DIRECTORY-SERVER-MIB.yaml", "data/ruby/snmp/mibs/DISMAN-EVENT-MIB.yaml", "data/ruby/snmp/mibs/DISMAN-EXPRESSION-MIB.yaml", "data/ruby/snmp/mibs/DISMAN-NSLOOKUP-MIB.yaml", "data/ruby/snmp/mibs/DISMAN-PING-MIB.yaml", "data/ruby/snmp/mibs/DISMAN-SCHEDULE-MIB.yaml", "data/ruby/snmp/mibs/DISMAN-SCRIPT-MIB.yaml", "data/ruby/snmp/mibs/DISMAN-TRACEROUTE-MIB.yaml", "data/ruby/snmp/mibs/DLSW-MIB.yaml", "data/ruby/snmp/mibs/DNS-RESOLVER-MIB.yaml", "data/ruby/snmp/mibs/DNS-SERVER-MIB.yaml", "data/ruby/snmp/mibs/DOCS-BPI-MIB.yaml", "data/ruby/snmp/mibs/DOCS-CABLE-DEVICE-MIB.yaml", "data/ruby/snmp/mibs/DOCS-IF-MIB.yaml", "data/ruby/snmp/mibs/DOT12-IF-MIB.yaml", "data/ruby/snmp/mibs/DS0-MIB.yaml", "data/ruby/snmp/mibs/DS0BUNDLE-MIB.yaml", "data/ruby/snmp/mibs/DS1-MIB.yaml", "data/ruby/snmp/mibs/DS3-MIB.yaml", "data/ruby/snmp/mibs/DSA-MIB.yaml", "data/ruby/snmp/mibs/DSMON-MIB.yaml", "data/ruby/snmp/mibs/EBN-MIB.yaml", "data/ruby/snmp/mibs/ENTITY-MIB.yaml", "data/ruby/snmp/mibs/ENTITY-SENSOR-MIB.yaml", "data/ruby/snmp/mibs/ETHER-CHIPSET-MIB.yaml", "data/ruby/snmp/mibs/ETHER-WIS.yaml", "data/ruby/snmp/mibs/EtherLike-MIB.yaml", "data/ruby/snmp/mibs/FDDI-SMT73-MIB.yaml", "data/ruby/snmp/mibs/FIBRE-CHANNEL-FE-MIB.yaml", "data/ruby/snmp/mibs/Finisher-MIB.yaml", "data/ruby/snmp/mibs/FLOW-METER-MIB.yaml", "data/ruby/snmp/mibs/FR-ATM-PVC-SERVICE-IWF-MIB.yaml", "data/ruby/snmp/mibs/FR-MFR-MIB.yaml", "data/ruby/snmp/mibs/FRAME-RELAY-DTE-MIB.yaml", "data/ruby/snmp/mibs/FRNETSERV-MIB.yaml", "data/ruby/snmp/mibs/FRSLD-MIB.yaml", "data/ruby/snmp/mibs/GSMP-MIB.yaml", "data/ruby/snmp/mibs/HC-ALARM-MIB.yaml", "data/ruby/snmp/mibs/HC-PerfHist-TC-MIB.yaml", "data/ruby/snmp/mibs/HC-RMON-MIB.yaml", "data/ruby/snmp/mibs/HCNUM-TC.yaml", "data/ruby/snmp/mibs/HDSL2-SHDSL-LINE-MIB.yaml", "data/ruby/snmp/mibs/HOST-RESOURCES-MIB.yaml", "data/ruby/snmp/mibs/HOST-RESOURCES-TYPES.yaml", "data/ruby/snmp/mibs/HPR-IP-MIB.yaml", "data/ruby/snmp/mibs/HPR-MIB.yaml", "data/ruby/snmp/mibs/IF-INVERTED-STACK-MIB.yaml", "data/ruby/snmp/mibs/IF-MIB.yaml", "data/ruby/snmp/mibs/IGMP-STD-MIB.yaml", "data/ruby/snmp/mibs/INET-ADDRESS-MIB.yaml", "data/ruby/snmp/mibs/INTEGRATED-SERVICES-GUARANTEED-MIB.yaml", "data/ruby/snmp/mibs/INTEGRATED-SERVICES-MIB.yaml", "data/ruby/snmp/mibs/INTERFACETOPN-MIB.yaml", "data/ruby/snmp/mibs/IP-FORWARD-MIB.yaml", "data/ruby/snmp/mibs/IP-MIB.yaml", "data/ruby/snmp/mibs/IPATM-IPMC-MIB.yaml", "data/ruby/snmp/mibs/IPMROUTE-STD-MIB.yaml", "data/ruby/snmp/mibs/IPOA-MIB.yaml", "data/ruby/snmp/mibs/IPV6-FLOW-LABEL-MIB.yaml", "data/ruby/snmp/mibs/IPV6-ICMP-MIB.yaml", "data/ruby/snmp/mibs/IPV6-MIB.yaml", "data/ruby/snmp/mibs/IPV6-MLD-MIB.yaml", "data/ruby/snmp/mibs/IPV6-TCP-MIB.yaml", "data/ruby/snmp/mibs/IPV6-UDP-MIB.yaml", "data/ruby/snmp/mibs/ISDN-MIB.yaml", "data/ruby/snmp/mibs/Job-Monitoring-MIB.yaml", "data/ruby/snmp/mibs/L2TP-MIB.yaml", "data/ruby/snmp/mibs/MALLOC-MIB.yaml", "data/ruby/snmp/mibs/MAU-MIB.yaml", "data/ruby/snmp/mibs/MIOX25-MIB.yaml", "data/ruby/snmp/mibs/MIP-MIB.yaml", "data/ruby/snmp/mibs/Modem-MIB.yaml", "data/ruby/snmp/mibs/MPLS-FTN-STD-MIB.yaml", "data/ruby/snmp/mibs/MPLS-LDP-ATM-STD-MIB.yaml", "data/ruby/snmp/mibs/MPLS-LDP-FRAME-RELAY-STD-MIB.yaml", "data/ruby/snmp/mibs/MPLS-LDP-GENERIC-STD-MIB.yaml", "data/ruby/snmp/mibs/MPLS-LDP-STD-MIB.yaml", "data/ruby/snmp/mibs/MPLS-LSR-STD-MIB.yaml", "data/ruby/snmp/mibs/MPLS-TC-STD-MIB.yaml", "data/ruby/snmp/mibs/MPLS-TE-STD-MIB.yaml", "data/ruby/snmp/mibs/MTA-MIB.yaml", "data/ruby/snmp/mibs/NETWORK-SERVICES-MIB.yaml", "data/ruby/snmp/mibs/NHRP-MIB.yaml", "data/ruby/snmp/mibs/NOTIFICATION-LOG-MIB.yaml", "data/ruby/snmp/mibs/OPT-IF-MIB.yaml", "data/ruby/snmp/mibs/OSPF-MIB.yaml", "data/ruby/snmp/mibs/OSPF-TRAP-MIB.yaml", "data/ruby/snmp/mibs/P-BRIDGE-MIB.yaml", "data/ruby/snmp/mibs/PARALLEL-MIB.yaml", "data/ruby/snmp/mibs/PerfHist-TC-MIB.yaml", "data/ruby/snmp/mibs/PIM-MIB.yaml", "data/ruby/snmp/mibs/PINT-MIB.yaml", "data/ruby/snmp/mibs/POWER-ETHERNET-MIB.yaml", "data/ruby/snmp/mibs/PPP-BRIDGE-NCP-MIB.yaml", "data/ruby/snmp/mibs/PPP-IP-NCP-MIB.yaml", "data/ruby/snmp/mibs/PPP-LCP-MIB.yaml", "data/ruby/snmp/mibs/PPP-SEC-MIB.yaml", "data/ruby/snmp/mibs/Printer-MIB.yaml", "data/ruby/snmp/mibs/PTOPO-MIB.yaml", "data/ruby/snmp/mibs/Q-BRIDGE-MIB.yaml", "data/ruby/snmp/mibs/RADIUS-ACC-CLIENT-MIB.yaml", "data/ruby/snmp/mibs/RADIUS-ACC-SERVER-MIB.yaml", "data/ruby/snmp/mibs/RADIUS-AUTH-CLIENT-MIB.yaml", "data/ruby/snmp/mibs/RADIUS-AUTH-SERVER-MIB.yaml", "data/ruby/snmp/mibs/RDBMS-MIB.yaml", "data/ruby/snmp/mibs/RFC1065-SMI.yaml", "data/ruby/snmp/mibs/RFC1155-SMI.yaml", "data/ruby/snmp/mibs/RFC1158-MIB.yaml", "data/ruby/snmp/mibs/RFC1213-MIB.yaml", "data/ruby/snmp/mibs/RFC1269-MIB.yaml", "data/ruby/snmp/mibs/RFC1271-MIB.yaml", "data/ruby/snmp/mibs/RFC1285-MIB.yaml", "data/ruby/snmp/mibs/RFC1316-MIB.yaml", "data/ruby/snmp/mibs/RFC1381-MIB.yaml", "data/ruby/snmp/mibs/RFC1382-MIB.yaml", "data/ruby/snmp/mibs/RFC1414-MIB.yaml", "data/ruby/snmp/mibs/RIPv2-MIB.yaml", "data/ruby/snmp/mibs/RMON-MIB.yaml", "data/ruby/snmp/mibs/RMON2-MIB.yaml", "data/ruby/snmp/mibs/ROHC-MIB.yaml", "data/ruby/snmp/mibs/ROHC-RTP-MIB.yaml", "data/ruby/snmp/mibs/ROHC-UNCOMPRESSED-MIB.yaml", "data/ruby/snmp/mibs/RS-232-MIB.yaml", "data/ruby/snmp/mibs/RSVP-MIB.yaml", "data/ruby/snmp/mibs/RTP-MIB.yaml", "data/ruby/snmp/mibs/SFLOW-MIB.yaml", "data/ruby/snmp/mibs/SIP-MIB.yaml", "data/ruby/snmp/mibs/SLAPM-MIB.yaml", "data/ruby/snmp/mibs/SMON-MIB.yaml", "data/ruby/snmp/mibs/SNA-NAU-MIB.yaml", "data/ruby/snmp/mibs/SNA-SDLC-MIB.yaml", "data/ruby/snmp/mibs/SNMP-COMMUNITY-MIB.yaml", "data/ruby/snmp/mibs/SNMP-FRAMEWORK-MIB.yaml", "data/ruby/snmp/mibs/SNMP-MPD-MIB.yaml", "data/ruby/snmp/mibs/SNMP-NOTIFICATION-MIB.yaml", "data/ruby/snmp/mibs/SNMP-PROXY-MIB.yaml", "data/ruby/snmp/mibs/SNMP-REPEATER-MIB.yaml", "data/ruby/snmp/mibs/SNMP-TARGET-MIB.yaml", "data/ruby/snmp/mibs/SNMP-USER-BASED-SM-MIB.yaml", "data/ruby/snmp/mibs/SNMP-USM-DH-OBJECTS-MIB.yaml", "data/ruby/snmp/mibs/SNMP-VIEW-BASED-ACM-MIB.yaml", "data/ruby/snmp/mibs/SNMPv2-MIB.yaml", "data/ruby/snmp/mibs/SNMPv2-SMI.yaml", "data/ruby/snmp/mibs/SNMPv2-TM.yaml", "data/ruby/snmp/mibs/SNMPv2-USEC-MIB.yaml", "data/ruby/snmp/mibs/SONET-MIB.yaml", "data/ruby/snmp/mibs/SOURCE-ROUTING-MIB.yaml", "data/ruby/snmp/mibs/SYSAPPL-MIB.yaml", "data/ruby/snmp/mibs/TCP-MIB.yaml", "data/ruby/snmp/mibs/TCPIPX-MIB.yaml", "data/ruby/snmp/mibs/TN3270E-MIB.yaml", "data/ruby/snmp/mibs/TN3270E-RT-MIB.yaml", "data/ruby/snmp/mibs/TOKEN-RING-RMON-MIB.yaml", "data/ruby/snmp/mibs/TOKENRING-MIB.yaml", "data/ruby/snmp/mibs/TOKENRING-STATION-SR-MIB.yaml", "data/ruby/snmp/mibs/TRANSPORT-ADDRESS-MIB.yaml", "data/ruby/snmp/mibs/TUNNEL-MIB.yaml", "data/ruby/snmp/mibs/UDP-MIB.yaml", "data/ruby/snmp/mibs/UPS-MIB.yaml", "data/ruby/snmp/mibs/VDSL-LINE-MIB.yaml", "data/ruby/snmp/mibs/VRRP-MIB.yaml", "data/ruby/snmp/mibs/WWW-MIB.yaml"]
  s.homepage = %q{http://snmplib.rubyforge.org}
  s.rdoc_options = ["--main", "README", "--title", "SNMP Library for Ruby"]
  s.require_paths = ["lib"]
  s.rubyforge_project = %q{snmplib}
  s.rubygems_version = %q{1.3.5}
  s.summary = %q{A Ruby implementation of SNMP (the Simple Network Management Protocol).}

  if s.respond_to? :specification_version then
    current_version = Gem::Specification::CURRENT_SPECIFICATION_VERSION
    s.specification_version = 2

    if Gem::Version.new(Gem::RubyGemsVersion) >= Gem::Version.new('1.2.0') then
    else
    end
  else
  end
end
